<?
include("ServerScriptHelper.php");
include("ArrayPacker.php");
include("uifc/PagedBlock.php");

$serverScriptHelper = new ServerScriptHelper();
$factory = $serverScriptHelper->getHtmlComponentFactory("base-import", "/base/import/importHandler.php?count=$count&logfile=$logfile");
$i18n = $serverScriptHelper->getI18n("base-import");
$page = $factory->getPage();
$cce = $serverScriptHelper->getCceClient();

if ($dataUpload == "none") {
	/*
	* No file was sent
	*/
	global $HTTP_REFERER;
	$scrollList = $factory->getScrollList("noFileSpecified",
	array("stats"));
	$scrollList->setEntryCountHidden(true);
	$scrollList->setHeaderRowHidden(true);
	$scrollList->addEntry(array($factory->getTextField("id",
	$i18n->interpolate("[[base-import.fileWasNoGood]]"), "r")));
	$cancelButton = $factory->getButton($HTTP_REFERER,
		"badFileButtonCancel");
	print $page->toHeaderHtml();
	print $scrollList->toHtml();
	print "<br>".$cancelButton->toHtml();
	print $page->toFooterHtml();
	exit;
}

if (!$logfile) {
	$fh = fopen($dataUpload, "r");
	if ( !$fh ) {
		print ($i18n->interpolate("[[base-import.couldNotOpenFile]]"));
	}

	// figure out the default quota size..
	$userDefaults = $cce->getObject("System", array(), "UserDefaults");
	$defaultQuota = $userDefaults["quota"];
	
	$Piped = "User\tname\tfullName\tpassword\tEmail.aliases\tsortName\tDisk.quota";
	$count = $i;
	while (!feof($fh)) {
		$line = fgets($fh, 4096);
		if (trim($line) == "") {
			$Piped .= "\nBLANK";
		} else {
			$peices = explode("\t", $line);
			$Piped .= "\nADD";
			# username
			$Piped .= "\t" . trim($peices[0]);	
			# full name
			$Piped .= "\t" . trim($peices[1]);	
			# password
			$Piped .= "\t" . trim($peices[2]);	
			# break up the Email.aliases
			if ($peices[3]) {
				$peices[3] = ereg_replace(" ", ",", trim($peices[3]));
				$peices[3] = ereg_replace(",,", ",", $peices[3]);
				$aliases = explode(",", $peices[3]);
				$Piped .= "\t" . arrayToString($aliases);		
			} else {
				$Piped .= "\t";
			}
			#sortName
			if ($peices[4])
				$Piped .= "\t" . trim($peices[4]);
			else
				$Piped .= "\t" . trim($pieces[2]);
			#quota
			if ($peices[5])
				$Piped .= "\t" . trim($peices[5]);
			else
				$Piped .= "\t" . $defaultQuota;

			$i++;
		}
	}
	
	$tmpFileName = tempnam("/tmp", "file");

	// FIXME?  race condition here??    notice that I create a file, then
	// I proceed to delete it..   this is done so that the logged in user
	// can create it (first copy is created by httpd)

	unlink($tmpFileName);
        $serverScriptHelper->putFile($tmpFileName, $Piped);

	$locales = $i18n->getLocales();

	$serverScriptHelper->shell("/usr/sausalito/handlers/base/import/import.pl $tmpFileName locale=$locales[0]", $fileName);
	$fileName = trim($fileName);
	print "<SCRIPT LANGUAGE=\"javascript\">location = \"/base/import/importHandler.php?count=$i&logfile=$fileName\"</SCRIPT>";
} else {
	# we have a log file.
	# show status

	# sanitize logfile name
	$logfile = ereg_replace("[^a-zA-Z0-9]", "_", $logfile);
	$fhData = $serverScriptHelper->getFile("/tmp/$logfile");
	$fhData = ereg_replace("\r", "", $fhData);
	$fhData = explode("\n", $fhData);
	array_pop($fhData); //get rid of blenk terminator
	$doneCount = trim(array_shift($fhData));
	$errorCount = trim(array_shift($fhData));
	$percent = ($doneCount / $count	) * 100;
	if ($percent < 100) {
		$block = new PagedBlock($page, "ImportStatus", $factory->getLabel("importStatus", false));
		#TODO: add message
		$block->addFormField(
			$factory->getTextField("none", $i18n->interpolate("[[base-import.creatingUsers]]", array("pos" => ($doneCount?$doneCount:"0"), "max" => $count)), "r"),
			$factory->getLabel("status")
		);
		$block->addFormField(
			$factory->getBar("progressField", round($percent,0)),
			$factory->getLabel("progressField")
		);
		print $page->toHeaderHtml();
		print "<SCRIPT LANGUAGE=\"javascript\">setTimeout(\"location.reload()\",8000);</SCRIPT>";
		print $block->toHtml();
		print $page->toFooterHtml();
		exit;
	} else {
		// done the import..
		print $page->toHeaderHtml();
		$error = $cce->errors();
		if ($errorCount) {
			// We have errors!
			$scrollList = $factory->getScrollList("importErrors", array("fullName", "name", "errorMessageHeader"), array(0,1));
			$scrollList->setEntryCountTags("[[base-import.errorCountSingular]]", "[[base-import.errorCountPlural]]");
			for ($i=0;$i<$errorCount;$i++) {
				# get the hash data
				$table = array();
				while (($line = array_shift($fhData))!="--") {
					ereg("^(.*)=(.*)$", $line, $regs);
					$table[$regs[1]] = $regs[2];
				}
				# get the messages
				$msg = "";
				while (($line = array_shift($fhData))!="--") {
					ereg("^(.*)$", $line, $regs);
					if($msg != "")
						$msg .= "\n";
					$msg .= trim($regs[1]);
				}
				
				$scrollList->addEntry( array(
					$factory->getTextField("fullName".$i,$table["fullName"],"r"),
					$factory->getTextField("name".$i,$table["name"], "r"),
					$factory->getTextField("errorMsg".$i,$msg, "r")
				));	
			}
			print $scrollList->toHtml()."<br>";

			print "<SCRIPT LANGUAGE=\"JAVASCRIPT\">\n";
			print $serverScriptHelper->toErrorJavascript($errors);
			print "</SCRIPT>\n";
		} else {
			// we imported successfully
			$scrollList = $factory->getScrollList("importSucceeded", array("message"));
			$scrollList->setEntryCountHidden(true);
			$scrollList->setHeaderRowHidden(true);
			$scrollList->addEntry( array( $factory->getLabel("importSucceededMessage")));
			print $scrollList->toHtml()."<br>";
		}
		$backButton = $factory->getBackButton("import.php");
		print $backButton->toHtml();
		print $page->toFooterHtml();
		print "<SCRIPT LANGUAGE=\"JAVASCRIPT\">\n";
		print $serverScriptHelper->toErrorJavascript($errors);
		print "</SCRIPT>\n";
	}
}
